#ifndef _blackbox_icon_hh
#define _blackbox_icon_hh

#include "debug.hh"
#include "session.hh"


class BlackboxIcon {
public:
  BlackboxIcon(BlackboxSession *, XID, XID = None, XID = None, Bool = False);
  ~BlackboxIcon(void);

  Window iconWindow(void) { return icon.window; }
  unsigned int Width(void) { return icon.width; }
  unsigned int Height(void) { return icon.height; }

  // event handling functions
  void buttonPressEvent(XButtonEvent *);
  void buttonReleaseEvent(XButtonEvent *);
  void motionNotifyEvent(XMotionEvent *);
  void enterNotifyEvent(XCrossingEvent *);
  void leaveNotifyEvent(XCrossingEvent *);

protected:

private:
  Bool use_icon_window, shaped, moving;
  Display *display;
  GC iconGC;

  struct {
    char *name;
    Pixmap pixmap, mask;
    Window client, window, subwindow, label;
    int x, y;
    unsigned int width, height,
      width_l, height_l,
      x_move, y_move;
  } icon;

  BlackboxSession *session;
  Debugger *debug;
};


#endif
